Index: GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TerrainFrameListener.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TerrainFrameListener.cpp	(revision 924)
+++ GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TerrainFrameListener.cpp	(revision 932)
@@ -191,14 +191,5 @@
 
 	//-- overlays
-	mMyStatsOverlay = OverlayManager::getSingleton().getByName("Example/Visibility/MyStatsOverlay");
-	mMyStatsAlgorithmInfo = OverlayManager::getSingleton().getOverlayElement("Example/Visibility/MyAlgorithmInfo");
-	mMyStatsAlgorithmInfo->setCaption("hehaah2");
-
-	char str[100]; sprintf(str,": %d", 0);
-	mMyStatsFpsInfo = OverlayManager::getSingleton().getOverlayElement("Example/Visibility/MyFpsInfo");
-	mMyStatsFpsInfo->setCaption(str);
-	
-	//mMyStatsAlgorithmInfo->setTop(top);
-	
+   
 	initVisStatsOverlay(); // visibility stats overlay
 	initHelpOverlay();     // help overlay
@@ -207,8 +198,22 @@
 	// show stats overlays
 	if (!DEMO_HACK)
+	{
 		showStats(true);
+	}
 	else
+	{
+		mMyStatsOverlay = OverlayManager::getSingleton().getByName("Example/Visibility/MyStatsOverlay");
+		mMyStatsAlgorithmInfo = OverlayManager::getSingleton().getOverlayElement("Example/Visibility/MyAlgorithmInfo");
+		mMyStatsAlgorithmInfo->setCaption("");
+	
+		const int top = 10;
+		mMyStatsAlgorithmInfo->setTop(top);
+
+		char str[100]; sprintf(str,": %d", 0);
+		mMyStatsFpsInfo = OverlayManager::getSingleton().getOverlayElement("Example/Visibility/MyFpsInfo");
+		mMyStatsFpsInfo->setCaption(str);
+
 		mMyStatsOverlay->show();
-
+	}
 
 	// note: larger magnification for terrain to show single objects
@@ -522,10 +527,10 @@
 
 	// no visibility manager available => no visibility scene manager, return
-	GtpVisibility::VisibilityManager *visManager;
+	GtpVisibility::VisibilityManager *visManager = NULL;
 	
 	if (!mSceneMgr->getOption("VisibilityManager", visManager))
 		return;
 
-	GtpVisibility::HierarchyInterface *hierarchyInterface;
+	GtpVisibility::HierarchyInterface *hierarchyInterface = NULL;
 	if (!mSceneMgr->getOption("HierarchyInterface", hierarchyInterface))
 		return;
Index: GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.cpp	(revision 926)
+++ GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.cpp	(revision 932)
@@ -153,7 +153,7 @@
 
 
-/*********************************************************/
-/*      TestCullingTerrainApplication implementation     */
-/*********************************************************/
+/**************************************************************/
+/*        TestCullingTerrainApplication implementation        */
+/**************************************************************/
 
 
@@ -193,4 +193,24 @@
 		 mViewCellsFilename = val.c_str();
 	}*/
+
+	Vector3 v = Vector3::UNIT_SCALE;
+
+	val = config.getSetting("ViewX");
+
+	if (!val.empty())
+		v.x = atof( val.c_str() );
+
+	val = config.getSetting("ViewY");
+	
+	if (!val.empty())
+		v.y = atof(val.c_str());
+
+	val = config.getSetting("ViewZ");
+	
+	if (!val.empty())
+		v.z = atof( val.c_str());
+
+	// set camera position accordingly
+	mCamNode->setPosition(v);
 }
 //-----------------------------------------------------------------------
@@ -274,7 +294,6 @@
 	if (1)
 	{
-		std::string logFilename = "IVLog" + index;
-		logFilename += ".log";
-
+		std::string logFilename = "IVLog" + Ogre::StringConverter().toString(index) + ".log";
+		
 		Log *log = LogManager::getSingleton().createLog(logFilename);
 		mIVReader->setLog(log);
@@ -661,6 +680,6 @@
 		{
 			// hack: set postion manually for vienna
-			mCamNode->setPosition(Vector3(830, 300, -540));
-			mCamNode->setOrientation(Quaternion(-0.3486, 0.0122, 0.9365, 0.0329));
+			//mCamNode->setPosition(Vector3(830, 300, -540));
+			//mCamNode->setOrientation(Quaternion(-0.3486, 0.0122, 0.9365, 0.0329));
 
 			// load iv files
Index: GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.h
===================================================================
--- GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.h	(revision 924)
+++ GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.h	(revision 932)
@@ -135,5 +135,6 @@
 	*/
 	void loadConfig(const String& filename);
-	// if hilly terrain should be loaded
+	
+	/// if hilly terrain should be loaded
 	static bool msShowHillyTerrain;
 